#!/usr/bin/env python
# coding: utf-8

# # Sudoku

# Os puzzles Sudoku são problemas de colocação de números inteiros entre 1 e $N^2$ numa matriz quadrada de dimensão $N^2$, por forma a que cada coluna e cada linha contenha todos os números, sem repetições. Além disso, cada matriz contém $N^2$ sub-matrizes quadradas disjuntas, de dimensão $N$, que deverão também elas conter os números entre  1 e $N^2$. 
# 
# Cada problema é dado por uma matriz parcialmente preenchida, cabendo ao jogador completá-la. 
# 
# O problema pode ser codificado através de um conjunto de $N^4$ constantes de tipo inteiro, correspondentes às posições da matriz, e escrevendo:
# 
# - $2 \times N^4$ desigualdades para os limites inferior e superior das constantes; 
# - $N^2$ restrições do tipo “todos diferentes”, uma para cada linha da matriz; 
# - $N^2$ restrições do tipo “todos diferentes”, uma para cada coluna da matriz; 
# - $N^2$ restrições do tipo “todos diferentes”, uma para cada sub-matriz da matriz.
# 
# Acrescem ainda as restrições (igualdades) correspondentes à definição de um tabuleiro concreto.
# 

# In[ ]:


from z3 import *


# Vamos necessitar de uma família de variáveis inteiras $x_{ij}$ e, para isso, vamos criar um dicionário do Python.

# In[ ]:


N = 3

s = Solver()

x = {}

# completar

